///home/berryj/link/bin/genMethods "-g" "-t" "DHyperGraph*" "-r" "MDHyperGraph*" "-I" "LINK/graph/DHyperGraph.h" "-y" "display_graphptr" "-m" "mark_graphptr" "-w" "free_graphptr" "-d" "graph" "-f" "__dHyperGraph_" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/DHyperGraph.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>

void display_graphptr(SCM, SCM, int);
void mark_graphptr(SCM);
void free_graphptr(SCM);

typedef DHyperGraph* _DHyperGraph_;

#define _DHyperGraph_DATA(x) ((DHyperGraph**) (EXTDATA(x)))
#define _DHyperGraph_IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<DHyperGraph* >::type))
#define _DHyperGraph_ISNT_DATA(x) (!_DHyperGraph_IS_DATA(x))

#define _DHyperGraph_CXX_DATA(x) (*(DHyperGraph**) (EXTDATA(VAL(x))))
#define _DHyperGraph_CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<DHyperGraph* >::type))
#define _DHyperGraph_CXX_ISNT_DATA(x) (!_DHyperGraph_CXX_IS_DATA(x))


static SCM is_DHyperGraph_(SCM i)
{
	if (_DHyperGraph_CXX_IS_DATA(i))
		return Truth;
	return Ntruth;
}

PRIMITIVE STk_init___dHyperGraph_()
{
	Wrapper<_DHyperGraph_>::type = STk_new_CXXwrapper_id(
			Wrapper<_DHyperGraph_>::name, 
			Wrapper<MDHyperGraph* >::name,
			(void (*)(SCM x, SCM port, int mode))
			display_graphptr,
			(void (*)(SCM x))mark_graphptr,
			(void (*)(SCM x))free_graphptr);
	Tcl_InitHashTable(&Register<_DHyperGraph_>::objTable, TCL_ONE_WORD_KEYS);
	STk_add_new_cpp_primitive("DHyperGraph?", tc_subr_1,
	(PRIMITIVE (*)(...))  is_DHyperGraph_);
	return UNDEFINED;
}

void genExtra__dHyperGraph_Methods(void);

PRIMITIVE STk_init_methods___dHyperGraph_()
{
	genExtra__dHyperGraph_Methods();
	return UNDEFINED;
}
